; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;   Mouse Clock by g0blinish
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


    .586                      ; create 32 bit code
    .model flat,stdcall       ; 32 bit memory model
    option casemap :none      ; case sensitive

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    include \masm32\include\windows.inc
    include \masm32\include\user32.inc
    include \masm32\include\shell32.inc 
    include \masm32\include\kernel32.inc
    include \masm32\include\comctl32.inc

    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\shell32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\comctl32.lib

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    WM_SHELLNOTIFY equ WM_USER+5
 
    IDI_MC equ 1
    IDM_EXIT equ 2
    IDI_TRAY equ 1003

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    WinMain          PROTO :DWORD,:DWORD,:DWORD,:DWORD
    WndProc          PROTO :DWORD,:DWORD,:DWORD,:DWORD
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

.data

    hInstance        dd ?
    hWnd             dd ?
    hPopupMenu       dd ?

    tthwnd			dd ?
	mcf				dd ?; on/off
	ttc db "tooltips_class32",0

	ts db "00:00:00",0
    HideDialogClass  db "mcClass",0
    HideDialogName   db "MouseClock",0

    note             NOTIFYICONDATA <>
	ti				TOOLINFO <>
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

.code

start:
    invoke FindWindow,ADDR HideDialogClass,0
    cmp eax,0
    je @F
    mov eax,0
    ret
    @@:

	mov mcf,MF_UNCHECKED ;=0
	invoke InitCommonControls
    invoke GetModuleHandle,0
    mov hInstance,eax
    
    invoke WinMain,hInstance,0,0,0
    invoke ExitProcess,eax

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

WinMain proc hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD
    ;---------------------------------
    ; Standard window creation stuff
    ;---------------------------------

    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG

    mov wc.cbSize,sizeof WNDCLASSEX
    mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
    mov wc.lpfnWndProc,OFFSET WndProc
    mov wc.cbClsExtra,0
    mov wc.cbWndExtra,0
    mov eax,hInst
    mov wc.hInstance,eax
    mov wc.hbrBackground,COLOR_WINDOW+1
    mov wc.lpszMenuName,0
    mov wc.lpszClassName,OFFSET HideDialogClass
    invoke LoadIcon,hInstance,202
    mov wc.hIcon,eax
    mov wc.hIconSm,eax
    mov note.hIcon,eax 
    
    invoke LoadCursor,0,IDC_ARROW
    mov wc.hCursor,eax


    invoke RegisterClassEx,ADDR wc

    invoke CreateWindowEx,WS_EX_LEFT,
                          ADDR HideDialogClass,
                          ADDR HideDialogName,
                          WS_OVERLAPPEDWINDOW,
                          CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
                          0,0,
                          hInstance,0
    mov hWnd,eax

;tooltip***************************************
 invoke CreateWindowEx,WS_EX_TOPMOST,
                          ADDR ttc,
                          0,
                          WS_POPUP+TTS_NOPREFIX + TTS_ALWAYSTIP,
                          CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
                          hWnd,0,
                          hInstance,0
	mov tthwnd,eax

	invoke SetWindowPos,eax,HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE + SWP_NOACTIVATE

     mov ti.cbSize,SizeOf(TOOLINFO);
     mov ti.uFlags,TTF_SUBCLASS;
     mov eax,hWnd
     mov ti.hWnd,eax
    mov eax,hInst
     mov ti.hInst,eax

	invoke GetClientRect,hWnd,ADDR ti.rect
    invoke SendMessage,tthwnd,TTM_ADDTOOL,0,ADDR ti
   ;--------------------------------------
    ; We do not want to clutter the task-
    ; bar so we do not show the app window
    ;--------------------------------------
    ; invoke ShowWindow,hWnd,SW_SHOW
    ;--------------------------------------


    StartLoop:
      invoke GetMessage,ADDR msg,0,0,0
      cmp eax,0
      je ExitLoop
      invoke TranslateMessage,ADDR msg
      invoke DispatchMessage,ADDR msg
      jmp StartLoop
    ExitLoop:
      
;      invoke KillTimer,hWnd,222
    mov eax,msg.wParam 
    ret

WinMain endp

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
 LOCAL pt:POINT
 LOCAL syst:SYSTEMTIME

        .if uMsg == WM_CREATE
            ;--------------------------------------------------------
            ; Create the applications tray icon menu options.
            ; These menu options are accessed when the user right
            ; clicks on the applications tray icon.
            ;--------------------------------------------------------
;            invoke CreatePopupMenu 
;            mov hPopupMenu,eax 
;            invoke AppendMenu,hPopupMenu,MF_STRING,IDM_HIDE,addr HideString 
;            invoke AppendMenu,hPopupMenu,MF_STRING,IDM_EXIT,addr ExitString 
		invoke LoadMenu,hInstance,201
			invoke GetSubMenu,eax,0
			mov hPopupMenu,eax

;        invoke SetTimer,hWin,222,25,0
            ;--------------------------------------------------------
            ; Send message to minimize application to system tray.
            ;--------------------------------------------------------
            invoke SendMessage,hWin,WM_SIZE,SIZE_MINIMIZED,0
            
    .elseif uMsg == WM_COMMAND 
            ;--------------------------------------------------------
            ; Handles the applications tray icon popup menu options.
            ;--------------------------------------------------------
            .if lParam == 0 
                .if wParam == IDM_EXIT
                    invoke KillTimer,hWnd,222
                    invoke Shell_NotifyIcon,NIM_DELETE,addr note 
                    invoke SendMessage,hWin,WM_DESTROY,0,0
                .elseif wParam == IDI_MC
;          CheckMenuItem_(hmnu,1,#MF_BYCOMMAND|(#MF_CHECKED*mou));Checked=8,unc=0
;MF_UNCHECKED                         equ 0h
;MF_CHECKED                           equ 8h
	mov eax,mcf
	xor eax,MF_CHECKED
	mov mcf,eax
	push eax
	or eax,MF_BYCOMMAND
	invoke CheckMenuItem,hPopupMenu,1,eax
	pop eax
	.if eax == 0
        invoke KillTimer,hWnd,222
	.else
        invoke SetTimer,hWin,222,25,0
	.endif
                .endif 
            .endif
 
    .elseif uMsg == WM_TIMER
;       If mou
	invoke SendMessage,tthwnd,TTM_TRACKACTIVATE,1,ADDR ti
	invoke GetCursorPos, ADDR pt
	invoke GetLocalTime, ADDR syst
	invoke GetTimeFormat,LOCALE_USER_DEFAULT,TIME_FORCE24HOURFORMAT,ADDR syst,0,ADDR ts,8
	mov	ti.lpszText,OFFSET ts
	invoke SendMessage,tthwnd,TTM_UPDATETIPTEXT,0, ADDR ti
;Macro MakeLong(low, high) 
;  low | high <<16 
;EndMacro 
	mov eax, pt.x;re.x
	and eax,65535
	mov ecx, pt.y;re.y
	and ecx,65535
	shl ecx,16
	or eax,ecx
	invoke SendMessage,tthwnd,TTM_TRACKPOSITION,0,eax

    .elseif uMsg == WM_DESTROY
            ;--------------------------------------------------------
            ; Shut down the application.
            ;--------------------------------------------------------
            invoke PostQuitMessage,0 

    .elseif uMsg == WM_SIZE 
            ;--------------------------------------------------------
            ; Minimize the application to the system tray.
            ;--------------------------------------------------------
            .if wParam == SIZE_MINIMIZED 
                mov note.cbSize,sizeof NOTIFYICONDATA 
                push hWin 
                pop note.hwnd 
                mov note.uID,IDI_TRAY
                mov note.uFlags,NIF_ICON+NIF_MESSAGE+NIF_TIP 
                mov note.uCallbackMessage,WM_SHELLNOTIFY  
                invoke lstrcpy,addr note.szTip,addr HideDialogName 
                invoke ShowWindow,hWin,SW_HIDE 
                invoke Shell_NotifyIcon,NIM_ADD,addr note 
            .endif 

    .elseif uMsg == WM_SHELLNOTIFY 
            .if wParam == IDI_TRAY 
                ;--------------------------------------------------------
                ; Display the popup menu at the specified location when
                ; the user right clicks on the applications tray icon.
                ;--------------------------------------------------------
                .if lParam == WM_RBUTTONDOWN or WM_RBUTTONUP 
                    invoke GetCursorPos,addr pt
                    invoke SetForegroundWindow,hWin 
                    invoke TrackPopupMenu,hPopupMenu,TPM_RIGHTALIGN,pt.x,pt.y,0,hWin,0 
                    invoke PostMessage,hWin,WM_NULL,0,0 
                .endif 
            .endif
    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam 
    ret 

WndProc endp

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

end start
